/*
 * CPUControl.h
 *
 *  Created on: May 29, 2012
 *      Author: andrew
 */

#ifndef CPUCONTROL_H_
#define CPUCONTROL_H_

#include <fstream>
#include <cstdlib>
#include <pthread.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include "constants.h"

const char ENABLE_FILENAME[] = "/sys/devices/system/cpu/cpu%d/online";
const unsigned int FILENAME_SIZE = 100;
const unsigned int MAX_THREADS = 500;
const unsigned int ADD_THREADS = 50;

class CPUControl {
public:
	CPUControl(unsigned int num_cores);
	virtual ~CPUControl();
	bool get_enabled(unsigned int core_id);
	void set_enabled(unsigned int core_id, bool enable);
	bool load_cpu(unsigned int new_threads = ADD_THREADS);
	void unload_cpu();
	unsigned int get_num_threads();
	pthread_t threads[MAX_THREADS];

private:
	static void* do_work(void* arg);
	unsigned int num_cores;
	unsigned int num_threads;

};

#endif /* CPUCONTROL_H_ */
